/*
	xchat-leetspeak.c
	-----------------
	passes all XP_CHANMSG text through a filter
	turning what you type and read into leetspeak
	(gets annoying very quickly, have fun)
	
	Elgin <gmorison@javanet.com>


	-----
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#define PLUGIN_NAME "Leetspeak"
#define PLUGIN_DESC "m4k3z y0ur t3xt l1k3 h4ck3rz"

#define USE_PLUGIN

#ifdef PLUGIN_CHECK
#include <stdio.h>
#endif
#include <ctype.h>
#include <string.h>
#include "xchat.h"
#include "plugin.h"

/* globals */
extern struct module *module_find(char *name);
struct xp_signal chanmsg_sig;
char *name = PLUGIN_NAME;
char *desc = PLUGIN_DESC;

/* protos */
#ifdef PLUGIN_CHECK
int main(int argc, char *argv[]);
#endif
void leetize(char *leet, char *text);
int leet_chanmsg (struct server *serv, char *from, char *ip, char *text, void *a, char c);
int (*chanmsg_next) (void *, void *, void *, void *, void *, char);

#ifdef PLUGIN_CHECK
/* main loop */
int main(int argc, char *argv[])
{
	char buf[512];
	char s[] = "Checking leetspeak module\0";
	
	printf(PLUGIN_NAME " (check)\n");
	leetize(buf, s);
	printf("> %s\n", s);
	printf("< %s\n", buf);
	
	return 0;
}
#endif

#ifndef PLUGIN_CHECK
int module_init(int ver, struct module *mod, struct session *sess)
{
	/* This check *MUST* be done first */
	if (ver != MODULE_IFACE_VER)
		return 1;
	
	if (module_find (name) != NULL)
	{
		/* We are already loaded */
		PrintText(sess, "\0035      Module " PLUGIN_NAME " already loaded \003 \n");
		return 1;
	}
	PrintText(sess, "\0035      Loaded module " PLUGIN_NAME "\003 \n");
	mod->name = name;
	mod->desc = desc;
		
	chanmsg_sig.signal = XP_CHANMSG;
	chanmsg_sig.callback = XP_CALLBACK(leet_chanmsg);
	chanmsg_sig.naddr = &chanmsg_next;
	chanmsg_sig.mod = mod;

	hook_signal(&chanmsg_sig);

	return 0;
}

void module_cleanup(struct module *mod, struct session *sess)
{
	PrintText(sess, "\0035      Unloaded module " PLUGIN_NAME "\003 \n");
}

int leet_chanmsg(struct server *serv, char *from, char *ip, char *text, void *a, char c)
{
	struct	session	*sess;
	char	buf[512];
	
	sess = serv->front_session;
	
	memset(buf, 0, sizeof(buf));
	leetize(buf, text);
	
	/*
	  replace old message with new.
	  thought this might cause a problem if
	  buf is bigger than text, but it
	  hasn't crashed during testing.
	  
	  i had to strcpy because the following
	  line didn't work...
	  
	  XP_CALLNEXT(chanmsg_next, serv, from, ip, buf, a, c);
	  
	  oh well
	*/
	strcpy(text, buf);
	
	XP_CALLNEXT(chanmsg_next, serv, from, ip, text, a, c);
}
#endif

void leetize(char *leet, char *text)
{
/*
   this function only substitutes certain letters for
   leet letters. a better function would also handle
   obvious contractions ("you" = "u") and sporadically
   capitalize some letters instead of changing all
   to lowercase. it should also watch out for words
   beginning with "s" ("sk1llz" instead of "zk1llz").
*/
	char c;
	char temp[512];
	
	memset(temp, 0, sizeof(char));
	
	while ( (c = tolower( *text++ )) != '\0' )
	{
		switch (c)
		{
			case 'a':
				strcat(temp, "4");
				break;
			case 'e':
				strcat(temp, "3");
				break;
			case 'f':
				strcat(temp, "ph");
				break;
			case 'i':
				strcat(temp, "1");
				break;
			case 'o':
				strcat(temp, "0");
				break;
			case 's':
				strcat(temp, "z");
				break;

			default:
				sprintf(temp, "%s%c", temp, c);
		}
	}
	strcpy(leet, temp);
}
